import { Component, type Entity, MotorComponent, SensorComponent, Handle } from "prototwin";

export class ConveyorController extends Component {
    public sensor: Handle<SensorComponent>;
    public motor: Handle<MotorComponent>;

    constructor(entity: Entity) {
        super(entity);
        this.sensor = this.handle(SensorComponent);
        this.motor = this.handle(MotorComponent);
    }

    public override initialize() {
        this.subscribe(this.sensor.value!.io.state, (state: boolean) => this.motor.value!.state = !state);
    }
}
